[bits 32]


%define TIMER_DEBUG 0 ; Turn to 1 to switch on timer debugging

%define MAX_LENGTH 20

extern printf
extern crypt

%if	TIMER_DEBUG == 1	
;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
	
extern time

;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
%endif


extern time

global crypt_print_pattern_found
global crypt_make_salt
global crypt_quick_strlen
global crypt_quick_memcpy
global crypt_strtolower
global crypt_make_tripcode
global crypt_compare_tripcode
global crypt_compare_str
global crypt_start_cracking


section .data

useableChars db ".",".","/","0","1","2","3","4","5","6","7","8","9","A","B","C",\
	"D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R",\
	"S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g",\
	"h","i","j","k","l","m","n","o","p","q","r","s","t","u","v",\
	"w","x","y","z","$"



patternBuffer: times 11 db 0

patternBufferSize dd 0
	
tripcodeBuffer: times 22 db 0
tripcodeLowerBuffer: times 22 db 0
	
passwordBuffer: times MAX_LENGTH+2 db 0
charsInc: times MAX_LENGTH dd 0

crypt_make_salt_returner db 0,0,0
	

%if	TIMER_DEBUG == 1	
;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
	
printf_pattern_found db 10,"%s - %s",10,0

;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG

%else
;;;;;;;;;;;;;;;;;;;;;;;; NORMAL

printf_pattern_found db "%s - %s",10,0

;;;;;;;;;;;;;;;;;;;;;;;; NORMAL

%endif


start_cracking_i dd 0


%if	TIMER_DEBUG == 1
;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG

timer_counter1 dd 0

hashes_passed dd 0

printf_hashes_passed db 13,"Passwords Tried Per Second: %u | Current Hash - %s | Current Password - %s",0

;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
%endif

section .text


crypt_print_pattern_found:
push tripcodeBuffer
push passwordBuffer
push printf_pattern_found
call printf

add esp,12
ret



crypt_quick_strlen:
mov esi,[esp+4]
xor ecx,ecx
.crypt_quick_strlen_loop:
lodsb
test al,al
je .crypt_quick_strlen_end
inc ecx
jmp .crypt_quick_strlen_loop
.crypt_quick_strlen_end:
mov eax,ecx
ret


crypt_quick_memcpy:


mov esi,[esp+4]
push esi
push esi
call crypt_quick_strlen
add esp,4


pop esi
mov edi,[esp+8]

rep movsb


ret




crypt_make_salt:

mov eax,[esp+4]
push eax
call crypt_quick_strlen
add esp,4

cmp eax,0
jne .make_salt_jmp1
mov byte[crypt_make_salt_returner],'.'
mov byte[crypt_make_salt_returner+1],0
jmp .make_salt_end

.make_salt_jmp1:

cmp eax,1
jne .make_salt_jmp2
mov byte[crypt_make_salt_returner],'H'
mov byte[crypt_make_salt_returner+1],'.'
jmp .make_salt_end

.make_salt_jmp2:

cmp eax,2
jne .make_salt_jmp3
mov ebx,[esp+4]
mov dl,byte[ebx+1]
mov byte[crypt_make_salt_returner],dl
mov byte[crypt_make_salt_returner+1],'H'
jmp .make_salt_end

.make_salt_jmp3:
mov ebx,[esp+4]
mov dl,byte[ebx+1]
mov dh,byte[ebx+2]

mov byte[crypt_make_salt_returner],dl
mov byte[crypt_make_salt_returner+1],dh

.make_salt_end:
mov eax, crypt_make_salt_returner
ret



crypt_strtolower:

mov esi,[esp+4]

.crypt_strtolower_loop:
lodsb
test al,al
je .crypt_strtolower_end

cmp al,65
jl .crypt_strtolower_loop
cmp al,90
jg .crypt_strtolower_loop

add al,32
mov byte[esi-1],al
jmp .crypt_strtolower_loop
.crypt_strtolower_end:

ret



crypt_make_tripcode:

mov eax,[esp+4]
push eax
call crypt_make_salt
add esp,4

mov ebx,[esp+4]
push eax
push ebx
call crypt
add esp,8

add eax,3

pusha
push tripcodeBuffer
push eax
call crypt_quick_memcpy
add esp,8
popa

push tripcodeLowerBuffer
push eax
call crypt_quick_memcpy
add esp,8

push tripcodeLowerBuffer
call crypt_strtolower
add esp,4
ret




crypt_compare_tripcode:

mov esi,tripcodeLowerBuffer
mov ecx,10
mov ebx,dword[patternBufferSize]
sub ecx,ebx
inc ecx
xor edx,edx

.crypt_compare_tripcode_loop:
cmp edx,ecx
je .crypt_compare_tripcode_end

mov eax,esi
add eax,edx

pusha
push eax
call crypt_compare_str
add esp,4

test al,al
jne .crypt_compare_tripcode_good

popa
inc edx
jmp .crypt_compare_tripcode_loop
.crypt_compare_tripcode_end:

xor eax,eax
ret


.crypt_compare_tripcode_good:
popa
xor eax,eax
inc eax
ret



crypt_compare_str:

mov esi,[esp+4]
mov ebx,patternBuffer
mov ecx,dword[patternBufferSize]
xor edx,edx

.crypt_compare_str_loop:
cmp edx,ecx
je .crypt_compare_str_good
lodsb
cmp byte[ebx+edx],al
jne .crypt_compare_str_end

inc edx

jmp .crypt_compare_str_loop

.crypt_compare_str_end:
xor eax,eax
ret

.crypt_compare_str_good:
xor eax,eax
inc eax
ret



crypt_start_cracking:

mov eax,[esp+4]
push eax
call crypt_quick_strlen
add esp,4

mov dword[patternBufferSize],eax
mov edx,eax

mov esi,[esp+4]
mov ebx,patternBuffer
xor ecx,ecx


.load_pattern_buffer_loop:
cmp ecx,edx
je .load_pattern_buffer_end
lodsb

mov byte[ebx+ecx],al

inc ecx
jmp .load_pattern_buffer_loop
.load_pattern_buffer_end:

push patternBuffer
call crypt_strtolower
add esp,4

%if	TIMER_DEBUG == 1
;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG

push 0
call time
add esp,4

mov dword[timer_counter1],eax

;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
%endif

.start_cracking_loop:

%if	TIMER_DEBUG == 1
;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG

push 0
call time
add esp,4

cmp eax,dword[timer_counter1]
jng ._timer_continue

push passwordBuffer
push tripcodeBuffer
push dword [hashes_passed]
push printf_hashes_passed
call printf
add esp,8

push 0
call time
add esp,4
mov dword[timer_counter1],eax

mov dword[hashes_passed],0

._timer_continue:

mov eax,dword[hashes_passed]
inc eax
mov dword[hashes_passed],eax

;;;;;;;;;;;;;;;;;;;;;;;; TIMER DEBUG
%endif

cmp byte[passwordBuffer+MAX_LENGTH],0
jne near .start_cracking_end

xor ecx,ecx
mov dword[start_cracking_i],ecx

	.check_incro_loop:
	mov ecx,dword[start_cracking_i]
	
	cmp byte[ecx+passwordBuffer],'$'
	jne .check_incro_end
	
	mov al,byte[useableChars]
	mov byte[passwordBuffer+ecx],al
	
	inc ecx
	
	mov edx,dword[charsInc+ecx*4]
	inc edx
	mov dword[charsInc+ecx*4],edx
	
	dec ecx
	
	inc ecx
	mov edx,dword[charsInc+ecx*4]
	dec ecx
	
	mov bl,byte[useableChars+edx]
	mov byte[passwordBuffer+ecx+1],bl
	
	mov dword[charsInc+ecx*4],1
	
	inc ecx
	mov dword[start_cracking_i],ecx
	jmp .check_incro_loop
	.check_incro_end:

push passwordBuffer
call crypt_make_tripcode
add esp,4

call crypt_compare_tripcode

test al,al
je .pattern_does_not_match

call crypt_print_pattern_found

.pattern_does_not_match:

mov ecx,dword[charsInc]
inc ecx
mov dword[charsInc],ecx
mov bl,byte[useableChars+ecx]

mov byte[passwordBuffer],bl


jmp .start_cracking_loop
.start_cracking_end:


ret



